# coding: utf-8

"""
    API Reference

    Detailed API reference documentation for Visier APIs. Includes all endpoints, headers, path parameters, query parameters, request body schema, response schema, JSON request samples, and JSON response samples.

    The version of the OpenAPI document: 22222222.99201.1926
    Contact: alpine@visier.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from visier_platform_sdk.models.target_project_for_tenants_list_dto import TargetProjectForTenantsListDTO
from visier_platform_sdk.models.users_to_user_group_request_dto import UsersToUserGroupRequestDTO
from typing import Optional, Set
from typing_extensions import Self

class UsersToUserGroupsRequestDTO(BaseModel):
    """
    UsersToUserGroupsRequestDTO
    """ # noqa: E501
    user_groups: Optional[List[UsersToUserGroupRequestDTO]] = Field(default=None, description="A list of objects representing the user groups and users to assign or remove.", alias="userGroups")
    target_project_for_tenants_list: Optional[TargetProjectForTenantsListDTO] = Field(default=None, description="Administrating tenants can specify the tenants and projects in which to assign users to user groups or remove users from user groups. Specify one `projectId` per `tenantCode`.  If omitted, the request is immediately published to production or applied to the ProjectID in the request header, if available, for the administrating tenant or TargetTenantID, if available.", alias="targetProjectForTenantsList")
    __properties: ClassVar[List[str]] = ["userGroups", "targetProjectForTenantsList"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UsersToUserGroupsRequestDTO from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in user_groups (list)
        _items = []
        if self.user_groups:
            for _item_user_groups in self.user_groups:
                if _item_user_groups:
                    _items.append(_item_user_groups.to_dict())
            _dict['userGroups'] = _items
        # override the default output from pydantic by calling `to_dict()` of target_project_for_tenants_list
        if self.target_project_for_tenants_list:
            _dict['targetProjectForTenantsList'] = self.target_project_for_tenants_list.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UsersToUserGroupsRequestDTO from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "userGroups": [UsersToUserGroupRequestDTO.from_dict(_item) for _item in obj["userGroups"]] if obj.get("userGroups") is not None else None,
            "targetProjectForTenantsList": TargetProjectForTenantsListDTO.from_dict(obj["targetProjectForTenantsList"]) if obj.get("targetProjectForTenantsList") is not None else None
        })
        return _obj


